import { Layout, Popup, PopupContent, PopupFooter, PopupHeader } from '@ensi-platform/core-components';
import { Row } from '@tanstack/react-table';
import { isEmpty } from 'lodash';
import { useRouter } from 'next/router';
import { useCallback, useEffect, useMemo, useRef, useState } from 'react';

import { Product, useProducts, useProductsMeta } from '@api/catalog';
import { useBindNameplateProducts, useSearchNameplateProducts } from '@api/content/nameplates';

import { useError, useSuccess } from '@context/modal';

import LoadWrapper from '@controls/LoadWrapper';

import AutoFilters from '@components/AutoFilters';
import Table, { useSorting, useTable } from '@components/Table';
import { getSelectColumn, getSettingsColumn } from '@components/Table/columns';
import { TableEmpty, TableFooter, TableHeader } from '@components/Table/components';

import { ITEMS_PER_PRODUCTS_PAGE, ModalMessages } from '@scripts/constants';
import { Button, scale, typography } from '@scripts/gds';
import { declOfNum, getPagination, getTotal, getTotalPages } from '@scripts/helpers';
import { useRedirectToNotEmptyPage, useTableList } from '@scripts/hooks';
import { useAutoColumns, useAutoFilters, useAutoTableData } from '@scripts/hooks/autoTable';

export interface AddProductsPopupProps {
    isOpen: boolean;
    onClose: () => void;
    nameplateId: number;
}

export const AddProductsPopup = ({ nameplateId, isOpen, onClose }: AddProductsPopupProps) => {
    const { query, push, pathname } = useRouter();

    const prevIsOpen = useRef(false);
    useEffect(() => {
        if (prevIsOpen.current === isOpen) return;

        push({ pathname, query: { entity_id: query.entity_id, page: 1 } }, undefined, { shallow: true });

        prevIsOpen.current = isOpen;
    }, [isOpen, pathname, push, query.entity_id]);

    const [selectedFilter, setSelectedFilter] = useState<Partial<any>>({});

    const { data: apiNameplateProducts } = useSearchNameplateProducts({
        filter: {
            nameplate_id: nameplateId,
        },
    });

    const { data: metaData, error: metaError } = useProductsMeta(isOpen);
    const meta = metaData?.data;

    const canViewDetailPage = true;
    const {
        metaField,
        values,
        filtersActive,
        URLHelper,
        reset,
        searchRequestFilter,
        emptyInitialValues,
        codesToSortKeys,
        clearInitialValue,
        searchRequestIncludes,
    } = useAutoFilters(meta, {
        isSaveToUrl: false,
    });

    const pageKey = 'products-page';

    const [{ backendSorting }, sortingPlugin] = useSorting<Product>(pageKey, meta?.fields);

    const { activePage, itemsPerPageCount, setItemsPerPageCount } = useTableList({
        defaultSort: meta?.default_sort,
        defaultPerPage: ITEMS_PER_PRODUCTS_PAGE,
        codesToSortKeys,
        pageKey,
    });

    const resetFilters = () => {
        reset();
        setSelectedFilter({});

        push({ pathname, query: { pid: query.pid } });
    };

    const uniqueExistingProductIds = useMemo(() => {
        const result: number[] = [];

        apiNameplateProducts?.data?.forEach(e => {
            if (!result.includes(e.product_id)) {
                result.push(e.product_id);
            }
        });

        return result;
    }, [apiNameplateProducts?.data]);

    const {
        data,
        isFetching: isLoading,
        error,
    } = useProducts(
        {
            include: searchRequestIncludes,
            sort: backendSorting,
            filter: {
                ...searchRequestFilter,
                ignore_id: uniqueExistingProductIds,
            },
            pagination: getPagination(activePage, itemsPerPageCount),
        },
        Boolean(meta) && !!backendSorting && !!apiNameplateProducts?.data && isOpen
    );

    const convertedTableData = useMemo(
        () =>
            data?.data.map(e => ({
                ...e,
                customListLink: '/products/catalog',
            })),
        [data?.data]
    );

    const products = useAutoTableData<Product>(convertedTableData, metaField);
    const autoGeneratedColumns = useAutoColumns(meta, canViewDetailPage);

    const columns = useMemo(
        () => [
            getSelectColumn(0, 'add-products-popup'),
            ...autoGeneratedColumns,
            getSettingsColumn({ columnsToDisable: [], visibleColumns: meta?.default_list }),
        ],
        [autoGeneratedColumns, meta?.default_list]
    );

    const total = getTotal(data);
    const totalPages = getTotalPages(data, itemsPerPageCount);

    useRedirectToNotEmptyPage({ activePage, itemsPerPageCount, total, shallow: true, pageKey });

    useError(error);
    useError(metaError);

    const bindProducts = useBindNameplateProducts(nameplateId);
    useSuccess(bindProducts.isSuccess && ModalMessages.SUCCESS_UPDATE);
    useError(bindProducts.error);

    const renderHeader = useCallback(
        (selected: Row<Product>[]) => (
            <TableHeader css={{ paddingLeft: 0, paddingRight: 0 }}>
                <Layout type="flex" gap={scale(4)} align="center" css={{ width: '100%', minHeight: scale(9) }}>
                    <Layout.Item>
                        <p css={{ lineHeight: '32px', ...typography('bodySm') }}>
                            <b>Найдено</b> {`${total} ${declOfNum(total, ['товар', 'товара', 'товаров'])}`}
                        </p>
                    </Layout.Item>
                    {!!selected.length && (
                        <>
                            <Layout.Item>
                                <p>
                                    <b>Выбрано:</b> {selected.length}
                                </p>
                            </Layout.Item>
                            <Layout.Item>
                                <Button
                                    type="button"
                                    onClick={async () => {
                                        try {
                                            await bindProducts.mutateAsync({
                                                ids: selected.map(e => Number(e.original.id)),
                                            });

                                            onClose();
                                        } catch (e) {
                                            console.error(e);
                                        }
                                    }}
                                >
                                    Привязать к тегу
                                </Button>
                            </Layout.Item>
                        </>
                    )}
                </Layout>
            </TableHeader>
        ),
        [bindProducts, onClose, total]
    );

    const table = useTable(
        {
            data: products,
            columns,
            meta: {
                tableKey: pageKey,
            },
        },
        [sortingPlugin]
    );

    return (
        <Popup open={isOpen} onClose={onClose} size="screen_lg" innerScroll>
            <PopupHeader>
                <h4>Выберите товары для добавления</h4>
            </PopupHeader>
            <PopupContent>
                <LoadWrapper isLoading={isLoading}>
                    <AutoFilters
                        initialValues={values}
                        filtersSettingsName="AddingNameplatesProductsFilterSettings"
                        emptyInitialValues={emptyInitialValues}
                        onSubmit={v => {
                            URLHelper(v);
                            push({ pathname, query: { pid: query.pid, page: 1 } });
                        }}
                        onResetFilters={resetFilters}
                        filtersActive={filtersActive}
                        clearInitialValue={clearInitialValue}
                        css={{ padding: 0, boxShadow: 'none', margin: 0 }}
                        meta={meta}
                        queryPart={{ entity_id: nameplateId }}
                    />
                    {renderHeader(table.getSelectedRowModel().flatRows)}
                    <Table instance={table} />
                </LoadWrapper>
            </PopupContent>
            <PopupFooter justify="end" cols={1}>
                <Layout.Item>
                    {products.length === 0 ? (
                        <TableEmpty
                            filtersActive={!isEmpty(selectedFilter)}
                            titleWithFilters="Товары с данными фильтрами не найдены"
                            titleWithoutFilters="Товары отсутствуют"
                            onResetFilters={() => {
                                reset();
                                setSelectedFilter({});
                            }}
                        />
                    ) : (
                        <TableFooter
                            pages={totalPages}
                            itemsPerPageCount={itemsPerPageCount}
                            setItemsPerPageCount={setItemsPerPageCount}
                            pageKey={pageKey}
                        />
                    )}
                </Layout.Item>
            </PopupFooter>
        </Popup>
    );
};
